<?php

class HomeDeviceX10 extends HomeDevice {
static $heyu;

	public static function install() {
		exec(self::$heyu . " engine");
	}

	public function __construct() {
		parent::__construct();
	}

	public function getIlluminationState($unit) {
		$s = $this->x10("onstate " . $unit->id . "");
		return $s == 1 || $s=="on" ? true : false;
	}

	public function getBrightnessState($unit) {
		$s = $this->x10("dimlevel " . $unit->id . "");
		return $s;
	}


	public function status() {
		print $this->x10("info") . PHP_EOL;
	}


	protected function x10($cmd) {
		// TODO: direct error into log
		$output = shell_exec(HomeDeviceX10::$heyu . " $cmd");
		return $output;
	}

	public function on($unit) {
		$this->x10("turn " . $unit->id . " on");
		return parent::on($unit);
	}

	public function onIfDark($unit) {
		$sunlight = shell_exec($this->minbin . "/sunlight");
		if ($sunlight < 75) {
			return $this->on($unit);
		}
		return 0;
	}
   
	public function setColorState($rgbColor) {
		print "Color is not supported" . PHP_EOL;
	}


	public function off($unit) {
		$this->x10("turn " . $unit->id . " off");
		return parent::off($unit);
	}

	public function allon($unit) {
		$this->x10("lightson " . $unit->id . "");
		return parent::allon($unit);
	}

	public function alloff($unit) {
		$this->x10("lightsoff $unit");
		return parent::alloff($unit);
	}

	public function setBrightnessState($unit, $level) {
		$x10level = floor(22-($level * 21)/100);
		$this->x10("dimb " . $unit->id . " $x10level");
		return parent::setBrightnessState($unit, $level);
	}

	public function dimBrightnessState($unit, $delta = 10) {
		$this->x10("dim " . $unit->id . " $delta");
		return parent::dimBrightnessState($unit, $delta);
	}

	public function raiseBrightnessState($unit, $delta = 10) {
		$this->x10("bright " . $unit->id . " $delta");
		return parent::raiseBrightnessState($unit, $delta);
	}


# TODO: getcode getcodetype getcodelist getcodecount

}

HomeDeviceX10::$heyu = "/usr/local/bin/heyu";


?>
